package org.jeecg.modules.stm.wb.survey.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.wb.survey.entity.WbSurveyPlan;
import org.jeecg.modules.stm.wb.survey.service.IWbSurveyPlanService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 调查计划
 * @Author: jeecg-boot
 * @Date:   2024-03-14
 * @Version: V1.0
 */

@RestController
@RequestMapping("/wb.survey/wbSurveyPlan")
@Slf4j
public class WbSurveyPlanController extends JeecgController<WbSurveyPlan, IWbSurveyPlanService> {
	@Autowired
	private IWbSurveyPlanService wbSurveyPlanService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbSurveyPlan
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "调查计划-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<WbSurveyPlan>> queryPageList(WbSurveyPlan wbSurveyPlan,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbSurveyPlan> queryWrapper = QueryGenerator.initQueryWrapper(wbSurveyPlan, req.getParameterMap());
		Page<WbSurveyPlan> page = new Page<WbSurveyPlan>(pageNo, pageSize);
		IPage<WbSurveyPlan> pageList = wbSurveyPlanService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param wbSurveyPlan
	 * @return
	 */
	@AutoLog(value = "调查计划-添加")

	@RequiresPermissions("wb.survey:wb_survey_plan:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbSurveyPlan wbSurveyPlan) {
		wbSurveyPlanService.save(wbSurveyPlan);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbSurveyPlan
	 * @return
	 */
	@AutoLog(value = "调查计划-编辑")

	@RequiresPermissions("wb.survey:wb_survey_plan:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbSurveyPlan wbSurveyPlan) {
		wbSurveyPlanService.updateById(wbSurveyPlan);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "调查计划-通过id删除")

	@RequiresPermissions("wb.survey:wb_survey_plan:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbSurveyPlanService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "调查计划-批量删除")

	@RequiresPermissions("wb.survey:wb_survey_plan:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbSurveyPlanService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "调查计划-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<WbSurveyPlan> queryById(@RequestParam(name="id",required=true) String id) {
		WbSurveyPlan wbSurveyPlan = wbSurveyPlanService.getById(id);
		if(wbSurveyPlan==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbSurveyPlan);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbSurveyPlan
    */
    @RequiresPermissions("wb.survey:wb_survey_plan:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbSurveyPlan wbSurveyPlan) {
        return super.exportXls(request, wbSurveyPlan, WbSurveyPlan.class, "调查计划");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb.survey:wb_survey_plan:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbSurveyPlan.class);
    }

}
